package csnetwork;

import java.net.*;
import java.nio.charset.Charset;
import java.io.*;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.Charset;
import java.util.*;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;


//카카오 클래스 
class kakao{
	private String place_name;
	private String address_name;
	
	public kakao(String place_name, String address_name) {
		this.place_name=place_name;
		this.address_name=address_name;
	}
	
	public String get_place_name() {
		return place_name;
	}
	
	public String get_address_name() {
		return address_name;
	}
}

//음식점 찾기 클래스 
class findRestaurant{
 private static String keyword; // 키워드
 private static int size; // 검색 결과 수
 private static String GEOCODE_URL; // 검색 주소
 private static String GEOCODE_USER_INFO="KakaoAK 4eb81c3defb0830a786e6fd84f3e3f7c"; // 카카오 API에서 발급받은 Rest API Key
 
	public List<kakao> search(String keyword){
	    URL obj; // kakao api url
	    List<kakao> list=new ArrayList<kakao>(); // 리스트: ((음식점 이름, 음식점 주소),...)

	    try{
	        // Kakao API - 키워드로 지역 검색
	        keyword = URLEncoder.encode("역곡"+keyword, "UTF-8");
	        size=15;
	        GEOCODE_URL=String.format("http://dapi.kakao.com/v2/local/search/keyword.json?query=%s&size=%d",keyword,size);
	        System.out.println("검색 URL: "+GEOCODE_URL);

	        obj = new URL(GEOCODE_URL);
	        HttpURLConnection con = (HttpURLConnection)obj.openConnection();

	        con.setRequestMethod("GET");
	        con.setRequestProperty("Authorization",GEOCODE_USER_INFO);
	        con.setRequestProperty("content-type", "application/json");
	        con.setDoOutput(true);
	        con.setUseCaches(false);
	        con.setDefaultUseCaches(false);

	        Charset charset = Charset.forName("UTF-8");
	        BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream(), charset));

	        String inputLine;
	        StringBuffer response = new StringBuffer();

	        while ((inputLine = in.readLine()) != null) {
	            response.append(inputLine);
	        }
	        String jsonString=response.toString();
	        
	        // Json 문자열 파싱 -> List<kakao>에 저장
	        JSONParser jsonParser = new JSONParser();
	        JSONObject jsonObject = (JSONObject) jsonParser.parse(jsonString);
	        JSONArray jsonArray = (JSONArray) jsonObject.get("documents");
	        try {
	            for(int i=0; i<jsonArray.size(); i++){
	                JSONObject objectInArray = (JSONObject) jsonArray.get(i);
	                String place_name=(String) objectInArray.get("place_name");
	                String address_name=(String) objectInArray.get("address_name");
	                kakao k=new kakao(place_name,address_name);
	                list.add(k);
	            }
	        }
	        catch(Exception e){
	            e.printStackTrace();
	        }
	    }
	    catch(Exception e){
	        // TODO Auto-generated catch block
	        e.printStackTrace();
	    }
	    return list;
	    }
}

//수신 스레드
//클라이언트의 메시지를 받는 역할
class ServerReceiver extends Thread {
	  server s;
	  Socket socket;
	  ServerSender server_sender;
	  ObjectInputStream in;
	  ObjectOutputStream out;
	  
	 // (접속한 클라이언트와 수신하는) 스레드 객체의 멤버 초기화 
	  ServerReceiver(server s, Socket socket, ServerSender server_sender) {
		  this.s=s;
		  this.socket = socket;
		  this.server_sender=server_sender;
		  try {
			  in = new ObjectInputStream(socket.getInputStream()); // 데이터 수신을 편하게 하도록 도와주는 객체 (접속한 클라이언트 -> 서버)
			  out = new ObjectOutputStream(socket.getOutputStream()); // 데이터 송신을 편하게 하도록 도와주는 객체 (서버 -> 접속한 클라이언트) 
		  } 
		  catch(IOException e) {}
	  }
	  
	  @Override
	  public void run() {
		  String name = "";
		  String code = "";
		  String client_key = "";
		  try {
			  // 처음 클라이언트가 접속한 상황 -> 대기하다가 수신된 클라이언트 이름을 받아서 clients에 저장, 현재 클라이언트 수 출력 
			  Packet packet = (Packet)in.readObject(); 
			  
			  // 클라이언트 이름 및 학번 확인
			  name = packet.get_msg();
			  name = name.substring(0,name.length()-9);
			  code = packet.get_msg();
			  code = code.substring(code.length()-9,code.length()-5);
			  
			  // 클라이언트 이름(학번 일부), 데이터 송신 관련 객체를 저장 
			  client_key=name+"("+code+")";
			  s.clients.put(client_key, out);
			  
			  // 클라이언트 입장 
			  System.out.println("#"+name+"님이 입장하셨습니다.");
			  server_sender.sendMemberToClient(client_key); // 접속한 클라이언트에게 온라인 멤버 리스트 보내주기
			  server_sender.sendToAllFirst(client_key,"#"+name+"님이 입장하셨습니다.");
			  System.out.println("현재 서버접속자 수는 " + s.clients.size() + "입니다.");

			  
			  // 이후에는 다음을 반복 (수신 대기하다 메시지 받으면 저장 -> 모든 클라이언트에게 메시지 송신)
			  while(in!=null) {
				  // 패킷 얻으면 분석 
				  packet = (Packet)in.readObject(); 
				  int cmd=packet.get_cmd();
				  String msg=packet.get_msg();
				  System.out.println(msg);
				  
				  // 멤버 리스트 요청
				  if(cmd==0x40) {
					  server_sender.sendMemberToClient(client_key);
				  }
				  // 음식점 검색
				  else if(cmd==0x30) {
					  	msg=msg.substring(1,msg.length());
					  	server_sender.sendRestaurantToClient(client_key,msg);
				  }
				  // 메시지 전송
				  else {
					  server_sender.sendToAll(msg);  
				  }
			  }
		  }
		  catch(Exception e) {
			  System.out.println("예외 메시지:"+e.getMessage());
		  }
		  // try문이 종료되면 다음을 실행 
		  // ex) 클라이언트가 나가서 in객체가 제대로 동작을 안 함
		  // 0x10
		  finally {
			  server_sender.sendToAll("#"+name+"님이 퇴장하셨습니다.");
			  s.clients.remove(client_key);
			  System.out.println("["+socket.getInetAddress()+":"+socket.getPort()+"]"+"에서 접속을 종료하였습니다.");
			  System.out.println("현재 서버접속자 수는 "+ s.clients.size()+"입니다.");
		  } 
	  } 
}

//송신 클래스 (스레드 x)
//클라이언트에게 메시지를 보내는 역할
class ServerSender{
	server s;
	
	 public ServerSender(server s) {
		 this.s=s;
	 }
	
	 // 특정 클라이언트에게 송신(멤버 리스트) : 0x40
	 void sendMemberToClient(String client_key) {
		 String members=""; 
		 Iterator it = s.clients.keySet().iterator();
		 while(it.hasNext()) {
			 members=members.concat(it.next()+"\n");
		 }
		 try {
			 ObjectOutputStream out = (ObjectOutputStream)s.clients.get(client_key);
			 out.writeObject(new Packet(0x40,members));
		 }
		 catch(Exception e){
			  System.out.println("예외 메시지:"+e.getMessage());
		 }
	 }
	 
	 // 특정 클라이언트에게 송신(음식점 검색) : 0x30
	 void sendRestaurantToClient(String client_key, String msg) {
		 String rsts="[음식점 검색] "+msg+'\n'; // 특수기호로 멤버를 보내는 메시지 구분 
		 List<kakao> list=s.rst.search(msg);
		 for(int i=0; i<list.size(); i++) {
			 if(i<10)
				 rsts=rsts.concat((i+1)+". "+list.get(i).get_place_name()+"("+list.get(i).get_address_name()+")"+"\n");
		 }
		 System.out.println(rsts);
		 try {
			 ObjectOutputStream out = (ObjectOutputStream)s.clients.get(client_key);
			 out.writeObject(new Packet(0x30,rsts));
		 }
		 catch(Exception e){
			  System.out.println("예외 메시지:"+e.getMessage());
		 }
	 }
	 
	 // (처음 통신) 모든 클라이언트에게 메시지 송신 : 0x20
	 void sendToAllFirst(String client_key, String msg) {
		 Iterator it = s.clients.keySet().iterator();
		 
		 // clients에 저장된 key값이 있으면 반복 
		 while(it.hasNext()) {
			 try {
				 String crt_client_key=(String) it.next();
				 System.out.println(crt_client_key);
				 System.out.println(client_key);
				 
				 // 처음 통신을 시도한 클라이언트 
				 if(crt_client_key.equals(client_key)) {
					 ObjectOutputStream out = (ObjectOutputStream)s.clients.get(client_key);
					 out.writeObject(new Packet(0x20,msg)); 
				 }
				 else {
					 ObjectOutputStream out = (ObjectOutputStream)s.clients.get(crt_client_key);
					 out.writeObject(new Packet(0x21,msg)); 
				 }
			 }
			 catch(Exception e){
				  System.out.println("예외 메시지:"+e.getMessage());
			 }
		 } 
	 }
	 
	 // 모든 클라이언트에게 메시지 송신 : 0x21
	 void sendToAll(String msg) {
		 Iterator it = s.clients.keySet().iterator();
		 
		 // clients에 저장된 key값이 있으면 반복 
		 while(it.hasNext()) {
			 try {
				 // 현재 클라이언트와 송신하기 위해서 out 객체 가져오기
				 ObjectOutputStream out = (ObjectOutputStream)s.clients.get(it.next());
				 // 현재 클라이언트에게 송신 
				 out.writeObject(new Packet(0x21,msg));
			 }
			 catch(Exception e){
				  System.out.println("예외 메시지:"+e.getMessage());
			 }
		 } 
	 }
}

public class server {
	// 접속한 클라이언트 목록  
	ConcurrentHashMap clients;
	// 음식점 검색 객체
	findRestaurant rst;
	 
	// key:클라이언트 이름+아이피, value:데이터 송신 관련 객체 (서버 -> 클라이언트)  
	 public server(findRestaurant rst) {
	  clients = new ConcurrentHashMap();
	  this.rst=rst;
	 }

	
	// 서버 오픈
	 public void start() {
		 ServerSocket serverSocket = null;
		 Socket socket = null;
	
		 try {
			 // 서버 컴퓨터의 7777 포트에서 채팅 프로그램 동작 
			 serverSocket = new ServerSocket(7777);
			 System.out.println("서버가 시작되었습니다.");
			 
			 // 서버의 송신 객체 생성
			 ServerSender server_sender=new ServerSender(this);
			 
			 // 반복 (접속할 클라이언트 대기 -> 접속한 클라이언트에 대한 수신 스레드 생성) 
			 while(true) {
				 // 대기하다가 연결된 클라이언트가 있으면 해당 클라이언트에 대한 소켓을 생성함
				 socket = serverSocket.accept(); 
				 System.out.println("["+socket.getInetAddress() + ":"+socket.getPort()+"]"+"에서 접속하였습니다.");
				 // 해당 클라이언트의 메시지를 수신하는 스레드 생성 
				 ServerReceiver thread = new ServerReceiver(this,socket,server_sender);
				 // 스레드 동작 
				 thread.start();
			 }
		 }
		 catch(Exception e) {
			  System.out.println("예외 메시지:"+e.getMessage());
		 }
	 } 
	  

	 public static void main(String args[]) {
		 // 음식점 검색 객체 생성
		 findRestaurant rst=new findRestaurant();
		 // 서버 객체 생성
		 server s = new server(rst);
		 // 서버 오픈
		 s.start();
	 }  
} 